//
//  WRTStatusClient.h
//  DDWRT-Monitor
//
//  Created by Matthieu Lalonde & Spike Grobstein on 11-05-27.
//  Copyleft 2011 Spurf CC BY-SH-NC. Some rights reserved.
//

#import <Foundation/Foundation.h>


@interface WRTStatusClient : NSObject {
@private
	BOOL			wrtReachable;
	NSString		*wanPort;
	NSString		*hostname;
	NSString		*protocol;
	int				port;
	NSString		*username;
	NSString		*password;
	
	NSMutableData	*receivedData;
	NSURLRequest	*theRequest;
	NSURLConnection	*theConnection;
	
	NSMutableArray	*requestQueue;
	
	id				delegate;
	SEL				callback;
	SEL				errorCallback;
	
	id				statusDelegate;
	SEL				statusCallbac;
	
	IBOutlet NSView					*credentialsView;
	IBOutlet NSFormCell				*fieldUsername;
	IBOutlet NSSecureTextFieldCell	*fieldPassword;
	IBOutlet NSButton				*buttonLogin;
}

@property(nonatomic, retain) NSMutableData	*receivedData;
@property(nonatomic, retain) id				delegate;
@property(nonatomic) SEL					callback;
@property(nonatomic) SEL					errorCallback;

@property(nonatomic, retain) id				statusDelegate;
@property(nonatomic) SEL					statusCallback;

- (id) initWithHostname:(NSString*)new_hostname port:(int)new_port protocol:(NSString*)new_protocol username:(NSString*)new_username password:(NSString*)new_password;

- (void) registerStatusCallback:(id)status_delegate callback:(SEL)status_callback;

- (NSMutableURLRequest*) buildRequest:(NSString*)uri;
- (NSMutableURLRequest*) requestForBandwidthViewerForInterface:(NSString*)interface;
- (void) getStatusUpdate:(NSString*)uri delegate:(id)requestDelegate callback:(SEL)requestSelector;
- (void) getConnectionStatus;

-(NSString *)getKey:(NSString *)stringData key:(NSString *)key;

- (BOOL) getWrtReachable;
- (void) setWrtReachable:(BOOL)new_wrtReachable;

- (NSString*) getWanPort;
- (void) setWanPort:(NSString*)new_wanport;

- (NSString*) getHostname;
- (void) setHostname:(NSString*)new_hostname;

- (NSString*) getProtocol;
- (void) setProtocol:(NSString*)new_protocol;

- (int) getPort;
- (void) setPort:(int)new_port;

- (NSString*) getUsername;
- (void) setUsername:(NSString*)new_username;

- (NSString*) getPassword;
- (void) setPassword:(NSString*)new_password;
/*
- (void) showCredentialsWindow;
- (IBAction) hideCredentialsWindow;
*/
@end
